archive/csharp/Lab5/AdoBackedModels_LeoSkadden/AdoBackedModels_LeoSkadden/Models/Customer.cs
using System;
using System.ComponentModel.DataAnnotations;

namespace UsingViewsAndModels_LeoSkadden.Models
{
	public class Customer
	{
		public Customer()
		{
		}

		public Customer(string firstName, string lastName, string address, string city, string state, string zip,
			string phone, string login, string password, DateTime birthDate, string comments, decimal purchases)
		{
			FirstName = firstName;
			LastName = lastName;
			Address = address;
			City = city;
			State = state;
			Zip = zip;
			Phone = phone;
			Login = login;
			Password = password;
			BirthDate = birthDate;
			Comments = comments;
			PurchasesToDate = purchases;
		}

		public int Id { get; set; }

		[Required(ErrorMessage = "Please enter a First Name.")]
		[RegularExpression(@"[A-Z][a-z]+", ErrorMessage = "Invalid First Name. Name must be capitalized and only letters.")]
		public string FirstName { get; set; }

		[Required(ErrorMessage = "Please enter a Last Name.")]
		[RegularExpression(@"[A-Z][a-z]+", ErrorMessage = "Invalid last Name.  Name must be capitalized and only letters.")]
		public string LastName { get; set; }

		// Using regex for address validation is almost impossible. For instance there is a town in California called carmel that doesn't use house numbers, this town would break almost every regex people would come up with.
		public string Address { get; set; }

		[RegularExpression(@"[A-Za-z\s]+", ErrorMessage = "Invalid city.")]
		public string City { get; set; }

		public string State { get; set; }

		[MinLength(5, ErrorMessage = "Invalid zip code.")]
		[MaxLength(5, ErrorMessage = "Invalid zip code.")]
		[RegularExpression(@"\d+", ErrorMessage = "Zip codes can only be numbers. (Sorry Canada)")]
		public string Zip { get; set; }

		[RegularExpression(@"((\(\d{3}\) ?)|(\d{3}-))?\d{3}-\d{4}", ErrorMessage = "Invalid phone number.")]
		public string Phone { get; set; }

		[Required(ErrorMessage = "Please enter a Login.")]
		[MinLength(5, ErrorMessage = "Login must be longer than 5 characters.")]
		[RegularExpression(@"[A-Za-z\d]+", ErrorMessage = "Login must be numbers or letters.")]
		public string Login { get; set; }

		[Required(ErrorMessage = "Please enter a Password.")]
		[MinLength(9, ErrorMessage = "Password must be longer than 9 characters.")]
		[RegularExpression(@"[A-Za-z\d]+", ErrorMessage = "Password must be numbers or letters.")]
		public string Password { get; set; }

		[Required(ErrorMessage = "Please enter a Birth Date.")]
		[DataType(DataType.Date)]
		public DateTime BirthDate { get; set; }

		public string Comments { get; set; }

		public decimal PurchasesToDate { get; set; }

		public override string ToString()
		{
			return FirstName + LastName;
		}
	}
}

archive/csharp/Lab5/AdoBackedModels_LeoSkadden/AdoBackedModels_LeoSkadden/Models/Product.cs
using System;
using System.ComponentModel.DataAnnotations;

namespace UsingViewsAndModels_LeoSkadden.Models
{
	public class Product
	{
		public Product()
		{
		}

		public Product(string name, decimal price, string description, string publisher, string category)
		{
			Name = name;
			Price = price;
			Description = description;
			Publisher = publisher;
			Category = category;
		}

		public Product(string name, decimal price, string description, string publisher, string category, byte[] picture)
		{
			Name = name;
			Price = price;
			Description = description;
			Publisher = publisher;
			Category = category;
			Picture = picture;
		}

		public int Id { get; set; }

		[Required(ErrorMessage = "Please enter a Name.")]
		[RegularExpression(@"[A-Z][a-z]+", ErrorMessage = "Invalid Name.  Name must be capitalized and only letters.")]
		public string Name { get; set; }

		[Required(ErrorMessage = "Please enter a price.")]
		[RegularExpression(@"\d+(\.\d{1,2})?", ErrorMessage = "Invalid price. Must be in the form 0.00")]
		public decimal Price { get; set; }

		public string Description { get; set; }

		public byte[] Picture { get; set; }

		public string Publisher { get; set; }

		public string Category { get; set; }

		public string PictureBase64 => Convert.ToBase64String(Picture ?? new byte[0]);

		public override string ToString()
		{
			return Name;
		}
	}
}

archive/csharp/Lab5/AdoBackedModels_LeoSkadden/AdoBackedModels_LeoSkadden/Models/Purchase.cs
using System;
using System.ComponentModel.DataAnnotations;

namespace UsingViewsAndModels_LeoSkadden.Models
{
	public class Purchase
	{
		public readonly string CustomerFirstName;
		public readonly string CustomerLastName;
		public readonly string ProductName;

		public Purchase()
		{
		}

		public Purchase(Customer customer, Product product, DateTime purchaseDate, decimal price)
		{
			PurchaseDate = purchaseDate;
			Customer = customer;
			Product = product;
			Price = price;
			CustomerFirstName = Customer.FirstName;
			CustomerLastName = Customer.LastName;
			ProductName = Product.Name;
		}

		public int Id { get; set; }

		public Customer Customer { get; set; }

		public Product Product { get; set; }

		public int CustId { get; set; }

		public int ProdId { get; set; }

		[Required(ErrorMessage = "Please enter a purchase date.")]
		[DataType(DataType.Date)]
		public DateTime PurchaseDate { get; set; }

		[Required(ErrorMessage = "Please enter a purchase price.")]
		[RegularExpression(@"\d+(\.\d{1,2})?", ErrorMessage = "Invalid price")]
		public decimal Price { get; set; }
	}
}

archive/csharp/Lab5/AdoBackedModels_LeoSkadden/AdoBackedModels_LeoSkadden/Controllers/CustomerController.cs
using System;
using System.Linq;
using System.Web.Mvc;
using UsingViewsAndModels_LeoSkadden.Models;

namespace UsingViewsAndModels_LeoSkadden.Controllers
{
	public class CustomerController : Controller
	{
		// GET
		public ActionResult Index()
		{
			ObjectFactory factory = new ObjectFactory();
			return View(factory.Customers);
		}

		[HttpGet]
		public ActionResult CreateCustomer()
		{
			return View("Create", new Customer());
		}

		public ActionResult CreateCustomer(Customer customer)
		{
			if ( !ModelState.IsValid )
			{
				return View("Create", customer);
			}

			ObjectFactory factory = new ObjectFactory();
			factory.SaveCustomer(customer);
			return RedirectToAction("Index");
		}

		[HttpGet]
		public ActionResult EditCustomer(int id)
		{
			ObjectFactory factory = new ObjectFactory();
			Customer customer = factory.Customers[id]; 
			
			ViewBag.id = id;
			return View("Edit", customer);
		}

		public ActionResult EditCustomer(Customer customer)
		{
			if (!ModelState.IsValid)
			{
				return View("Edit");
			}
			ObjectFactory factory = new ObjectFactory();
			factory.UpdateCustomer(customer.Id, customer);
			return RedirectToAction("Index");
		}

		public ActionResult DeleteCustomer(int id, bool confirm)
		{
			if ( confirm )
			{
				ObjectFactory factory = new ObjectFactory();
				factory.DeleteCustomer(id);
			}

			return RedirectToAction("Index");
		}
	}
}

archive/csharp/Lab5/AdoBackedModels_LeoSkadden/AdoBackedModels_LeoSkadden/Controllers/ListsController.cs
using System.Linq;
using System.Web.Mvc;
using UsingViewsAndModels_LeoSkadden.Models;

namespace UsingViewsAndModels_LeoSkadden.Controllers
{
	public class ListsController : Controller
	{
		// GET: Lists
		public ActionResult Index()
		{
			return View();
		}

		public ActionResult Customer()
		{
			ObjectFactory factory = new ObjectFactory();
			return View("CustomerView", factory.Customers.Values.ToList());
		}

		public ActionResult Product()
		{
			ObjectFactory factory = new ObjectFactory();
			return View("ProductView", factory.Products.Values.ToList());
		}

		public ActionResult Purchase()
		{
			ObjectFactory factory = new ObjectFactory();
			return View("PurchaseView", factory.Purchases);
		}
	}
}

archive/csharp/Lab5/AdoBackedModels_LeoSkadden/AdoBackedModels_LeoSkadden/Controllers/ProductController.cs
using System;
using System.IO;
using System.Web;
using System.Web.Mvc;
using System.Web.Services.Protocols;
using UsingViewsAndModels_LeoSkadden.Models;

namespace UsingViewsAndModels_LeoSkadden.Controllers
{
	public class ProductController : Controller
	{
		// GET: Product
		public ActionResult Index()
		{
			ObjectFactory factory = new ObjectFactory();
			return View(factory.Products);
		}

		[HttpGet]
		public ActionResult CreateProduct()
		{
			return View("Create", new Product());
		}

		public ActionResult CreateProduct(Product product)
		{
			HttpPostedFileWrapper pic = (HttpPostedFileWrapper)Request.Files["pic"];
			BinaryReader reader = new BinaryReader(pic.InputStream);
			product.Picture = reader.ReadBytes(pic.ContentLength);

			ObjectFactory factory = new ObjectFactory();
			factory.SaveProduct(product);
			return RedirectToAction("Index");
		}

		public ActionResult EditProduct(int id)
		{
			ObjectFactory factory = new ObjectFactory();
			Product product;
			if ( Request.HttpMethod == "GET" )
			{
				product = factory.Products[id];
				ViewBag.id = id;
				return View("Edit", product);
			}
			else
			{
				byte[] picture = factory.Products[id].Picture;
				if ( Request.Files["Pic"] != null )
				{
					picture = null;
					HttpPostedFileWrapper pic = (HttpPostedFileWrapper) Request.Files["pic"];
					BinaryReader reader = new BinaryReader(pic.InputStream);
					picture = reader.ReadBytes(pic.ContentLength);
				}

				product = new Product(Request.Form["Name"], Convert.ToDecimal(Request.Form["Price"]), Request.Form["Description"], Request.Form["Publisher"], Request.Form["Category"], picture);
				factory.UpdateProduct(id, product);
				return RedirectToAction("Index");
			}
		}

		public ActionResult DeleteProduct(int id, bool confirm)
		{
			if ( confirm )
			{
				ObjectFactory factory = new ObjectFactory();
				factory.DeleteProduct(id);
			}

			return RedirectToAction("Index");
		}
	}
}

archive/csharp/Lab5/AdoBackedModels_LeoSkadden/AdoBackedModels_LeoSkadden/Controllers/PurchaseController.cs
using System;
using System.Web.Mvc;
using UsingViewsAndModels_LeoSkadden.Models;

namespace UsingViewsAndModels_LeoSkadden.Controllers
{
	public class PurchaseController : Controller
	{
		// GET: Purchase
		public ActionResult Index()
		{
			ObjectFactory factory = new ObjectFactory();
			return View(factory.Purchases);
		}

		[HttpGet]
		public ActionResult CreatePurchase()
		{
			return View("Create", new Purchase());
		}

		public ActionResult CreatePurchase(Purchase purchase)
		{
			if ( !ModelState.IsValid )
			{
				return View("Create", purchase);
			}
			ObjectFactory factory = new ObjectFactory();

			Customer customer = factory.Customers[int.Parse(Request.Form["CustId"])];
			customer.Id = int.Parse(Request.Form["CustId"]);
			Product product = factory.Products[int.Parse(Request.Form["ProdId"])];
			product.Id = int.Parse(Request.Form["ProdId"]);

			purchase.Customer = customer;
			purchase.Product = product;
			factory.SavePurchase(purchase);
			return RedirectToAction("Index");
		}

		[HttpGet]
		public ActionResult EditPurchase(int id)
		{
			ObjectFactory factory = new ObjectFactory();
			Purchase purchase = factory.Purchases[id];

			ViewBag.id = id;
			return View("Edit", purchase);
		}

		public ActionResult EditPurchase(Purchase purchase)
		{
			if ( !ModelState.IsValid )
			{
				return View("Edit", purchase);
			}
			ObjectFactory factory = new ObjectFactory();

			Customer customer = factory.Customers[int.Parse(Request.Form["CustId"])];
			customer.Id = int.Parse(Request.Form["CustId"]);

			Product product = factory.Products[int.Parse(Request.Form["ProdId"])];
			product.Id = int.Parse(Request.Form["ProdId"]);

			purchase = new Purchase(customer, product, DateTime.Parse(Request.Form["PurchaseDate"]), decimal.Parse(Request.Form["Price"]));
			factory.UpdatePurchase(purchase.Id, purchase);
			return RedirectToAction("Index");
		}

		public ActionResult DeletePurchase(int id, bool confirm)
		{
			if ( confirm )
			{
				ObjectFactory factory = new ObjectFactory();
				factory.DeletePurchase(id);
			}

			return RedirectToAction("Index");
		}
	}
}

archive/csharp/Lab5/AdoBackedModels_LeoSkadden/AdoBackedModels_LeoSkadden/Views/Lists/CustomerView.cshtml
@using UsingViewsAndModels_LeoSkadden.Models
@model IEnumerable<UsingViewsAndModels_LeoSkadden.Models.Customer>

@{
	Layout = null;
}

<!DOCTYPE html>

<html>
<head>
	<meta name="viewport" content="width=device-width"/>
	<title>CustomerView</title>
</head>
<body>
<p>
	@Html.ActionLink("Create New", "Create")
</p>
<table class="table">
	<tr>
		<th>
			@Html.DisplayNameFor(model => model.FirstName)
		</th>
		<th>
			@Html.DisplayNameFor(model => model.LastName)
		</th>
		<th>
			@Html.DisplayNameFor(model => model.Address)
		</th>
		<th>
			@Html.DisplayNameFor(model => model.City)
		</th>
		<th>
			@Html.DisplayNameFor(model => model.State)
		</th>
		<th>
			@Html.DisplayNameFor(model => model.Zip)
		</th>
		<th>
			@Html.DisplayNameFor(model => model.Phone)
		</th>
		<th>
			@Html.DisplayNameFor(model => model.Login)
		</th>
		<th>
			@Html.DisplayNameFor(model => model.Password)
		</th>
		<th>
			@Html.DisplayNameFor(model => model.BirthDate)
		</th>
		<th>
			@Html.DisplayNameFor(model => model.Comments)
		</th>
		<th>
			@Html.DisplayNameFor(model => model.PurchasesToDate)
		</th>
		<th></th>
	</tr>

	@foreach ( Customer item in Model )
	{
		<tr>
			<td>
				@Html.DisplayFor(modelItem => item.FirstName)
			</td>
			<td>
				@Html.DisplayFor(modelItem => item.LastName)
			</td>
			<td>
				@Html.DisplayFor(modelItem => item.Address)
			</td>
			<td>
				@Html.DisplayFor(modelItem => item.City)
			</td>
			<td>
				@Html.DisplayFor(modelItem => item.State)
			</td>
			<td>
				@Html.DisplayFor(modelItem => item.Zip)
			</td>
			<td>
				@Html.DisplayFor(modelItem => item.Phone)
			</td>
			<td>
				@Html.DisplayFor(modelItem => item.Login)
			</td>
			<td>
				@Html.DisplayFor(modelItem => item.Password)
			</td>
			<td>
				@Html.DisplayFor(modelItem => item.BirthDate)
			</td>
			<td>
				@Html.DisplayFor(modelItem => item.Comments)
			</td>
			<td>
				@Html.DisplayFor(modelItem => item.PurchasesToDate)
			</td>
			<td>
				@Html.ActionLink("Edit", "Edit", new {/* id=item.PrimaryKey */}) |
				@Html.ActionLink("Details", "Details", new {/* id=item.PrimaryKey */}) |
				@Html.ActionLink("Delete", "Delete", new {/* id=item.PrimaryKey */})
			</td>
		</tr>
	}

</table>
</body>
</html>

archive/csharp/Lab5/AdoBackedModels_LeoSkadden/AdoBackedModels_LeoSkadden/Views/Lists/Index.cshtml
@{
	Layout = null;
}

<!DOCTYPE html>

<html>
<head>
	<meta name="viewport" content="width=device-width"/>
	<title>IndexView</title>
</head>
<body>
@Html.ActionLink("Customers", "Customer")
@Html.ActionLink("Products", "Product")
@Html.ActionLink("Purchases", "Purchase")
</body>
</html>

archive/csharp/Lab5/AdoBackedModels_LeoSkadden/AdoBackedModels_LeoSkadden/Views/Lists/ProductView.cshtml
@using UsingViewsAndModels_LeoSkadden.Models
@model IEnumerable<UsingViewsAndModels_LeoSkadden.Models.Product>

@{
	Layout = null;
}

<!DOCTYPE html>

<html>
<head>
	<meta name="viewport" content="width=device-width"/>
	<title>ProductView</title>
</head>
<body>
<p>
	@Html.ActionLink("Create New", "Create")
</p>
<table class="table">
	<tr>
		<th>
			@Html.DisplayNameFor(model => model.Name)
		</th>
		<th>
			@Html.DisplayNameFor(model => model.Price)
		</th>
		<th>
			@Html.DisplayNameFor(model => model.Description)
		</th>
		<th>
			@Html.DisplayNameFor(model => model.Publisher)
		</th>
		<th>
			@Html.DisplayNameFor(model => model.Category)
		</th>
		<th></th>
	</tr>

	@foreach ( Product item in Model )
	{
		<tr>
			<td>
				@Html.DisplayFor(modelItem => item.Name)
			</td>
			<td>
				@Html.DisplayFor(modelItem => item.Price)
			</td>
			<td>
				@Html.DisplayFor(modelItem => item.Description)
			</td>
			<td>
				@Html.DisplayFor(modelItem => item.Publisher)
			</td>
			<td>
				@Html.DisplayFor(modelItem => item.Category)
			</td>
			<td>
				@Html.ActionLink("Edit", "Edit", new {/* id=item.PrimaryKey */}) |
				@Html.ActionLink("Details", "Details", new {/* id=item.PrimaryKey */}) |
				@Html.ActionLink("Delete", "Delete", new {/* id=item.PrimaryKey */})
			</td>
		</tr>
	}

</table>
</body>
</html>

archive/csharp/Lab5/AdoBackedModels_LeoSkadden/AdoBackedModels_LeoSkadden/Views/Lists/PurchaseView.cshtml
@using UsingViewsAndModels_LeoSkadden.Models
@model IEnumerable<UsingViewsAndModels_LeoSkadden.Models.Purchase>

@{
	Layout = null;
}

<!DOCTYPE html>

<html>
<head>
	<meta name="viewport" content="width=device-width"/>
	<title>PurchaseView</title>
</head>
<body>
<p>
	@Html.ActionLink("Create New", "Create")
</p>
<table class="table">
	<tr>
		<th>
			@Html.DisplayNameFor(model => model.PurchaseDate)
		</th>
		<th>
			@Html.DisplayNameFor(model => model.Price)
		</th>
		<th></th>
	</tr>

	@foreach ( Purchase item in Model )
	{
		<tr>
			<td>
				@Html.DisplayFor(modelItem => item.PurchaseDate)
			</td>
			<td>
				@Html.DisplayFor(modelItem => item.Price)
			</td>
			<td>
				@Html.ActionLink("Edit", "Edit", new {/* id=item.PrimaryKey */}) |
				@Html.ActionLink("Details", "Details", new {/* id=item.PrimaryKey */}) |
				@Html.ActionLink("Delete", "Delete", new {/* id=item.PrimaryKey */})
			</td>
		</tr>
	}

</table>
</body>
</html>